;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
.macro GRUEN_ON
	cbi (GRUEN_PORT),(GRUEN_PIN_NR)
.endm
.macro GRUEN_OFF
	sbi (GRUEN_PORT),(GRUEN_PIN_NR)
.endm
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
.macro GELB_ON
	cbi (GELB_PORT),(GELB_PIN_NR)
.endm
.macro GELB_OFF
	sbi (GELB_PORT),(GELB_PIN_NR)
.endm
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
.macro ROT_ON
	cbi (ROT_PORT),(ROT_PIN_NR)
.endm
.macro ROT_OFF
	sbi (ROT_PORT),(ROT_PIN_NR)
.endm
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
.macro GRUEN2_ON
	cbi (GRUEN2_PORT),(GRUEN2_PIN_NR)
.endm
.macro GRUEN2_OFF
	sbi (GRUEN2_PORT),(GRUEN2_PIN_NR)
.endm
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
.macro GELB2_ON
	cbi (GELB2_PORT),(GELB2_PIN_NR)
.endm
.macro GELB2_OFF
	sbi (GELB2_PORT),(GELB2_PIN_NR)
.endm
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
.macro BEEP_ON
	cbi (BEEP_PORT),(BEEP_PIN_NR)
.endm
.macro BEEP_OFF
	sbi (BEEP_PORT),(BEEP_PIN_NR)
.endm
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
.macro POWER_ON
	sbi (POWER_PORT),(POWER_PIN_NR)
.endm
.macro POWER_OFF
	cbi (POWER_PORT),(POWER_PIN_NR)
.endm
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
.macro LUEFTER_ON
	sbi (LUEFTER_PORT),(LUEFTER_PIN_NR)
.endm
.macro LUEFTER_OFF
	cbi (LUEFTER_PORT),(LUEFTER_PIN_NR)
.endm
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
; Clock																			
.macro LED_DAT_H
	sbi (DAT_PORT),(DAT_PIN_NR)		; Data-Pin auf HIGH	
.endm							
.macro LED_DAT_L
	cbi (DAT_PORT),(DAT_PIN_NR)		; Data-Pin auf LOW	
.endm
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
; Data shifts one place to the right on each LOW-to-HIGH transition of the clock (CP) input							
; and enters into Q0, which is the logical AND of the two data inputs (DSA and DSB) that							
;																													
; Bei jedem bergang von LOW nach HIGH des Takteingangs (CP) werden die Daten um eine Stelle nach rechts verschoben	
; und geht in Q0 ein, das das logische UND der beiden Dateneingnge (DSA und DSB) ist								
.macro LED_ENABLE
	cbi (CLOCK_PORT),(CLOCK_PIN_NR)	; Clock-Pin auf LOW	
	sbi (CLOCK_PORT),(CLOCK_PIN_NR)	; Clock-Pin auf HIGH
.endm
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
