; ##############################################################################
; ##############################################################################
; ##############################################################################
; z.B. "02"																		
ZAHL_TEMP1:
	clr temp2
	clr temp3
	clr temp4
	rcall FUNKTION_HEX_ASCII_TEMP1_4
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; z.B: "1234"																	
ZAHL_TEMP1_2:
	clr temp3
	clr temp4
	rcall FUNKTION_HEX_ASCII_TEMP1_4

	cpi temp5,(ASCII_0)
	brne ZAHL_TEMP1_2_RUN
	clr temp5

	cpi temp4,(ASCII_0)
	brne ZAHL_TEMP1_2_RUN
	clr temp4

	cpi temp3,(ASCII_0)
	brne ZAHL_TEMP1_2_RUN
	clr temp3

	cpi temp2,(ASCII_0)
	brne ZAHL_TEMP1_2_RUN
	clr temp2

ZAHL_TEMP1_2_RUN:
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Version 10/2017																
;																				
;	Value: 0...	4.294.967.295													
;																				
;	INPUT: 	temp1	(BYTE1)														
;	 		temp2	(BYTE2)														
;			temp3	(BYTE3)														
;			temp4	(BYTE4)														
;																				
;	OUTPUT:	temp1	(		    1-er Stelle)									
;			temp2	(		   10-er Stelle)									
;			temp3	(         100-er Stelle)									
;			temp4	(       1.000-er Stelle)									
;			temp5	(      10.000-er Stelle)									
;			temp6	(     100.000-er Stelle)									
;			temp7	(   1.000.000-er Stelle)									
;			temp8	(  10.000.000-er Stelle)									
;			temp9	( 100.000.000-er Stelle)									
; 			R0		(1.000.000.000-er Stelle)									
FUNKTION_HEX_ASCII_TEMP1_4:
	clr temp
FUNKTION_HEX_ASC_1000000000:; 100.000.000
	inc temp
	subi temp1, BYTE1    (1000000000)
	sbci temp2, BYTE2    (1000000000)
	sbci temp3, BYTE3    (1000000000)
	sbci temp4, BYTE4    (1000000000)
	brcc FUNKTION_HEX_ASC_1000000000
	dec  temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird R0) auf dem Stack sichern            
	subi temp1, BYTE1   (-1000000000)
	sbci temp2, BYTE2   (-1000000000)
	sbci temp3, BYTE3   (-1000000000)
	sbci temp4, BYTE4   (-1000000000)

	clr temp
FUNKTION_HEX_ASC_100000000:; 100.000.000
	inc temp
	subi temp1, BYTE1    (100000000)
	sbci temp2, BYTE2    (100000000)
	sbci temp3, BYTE3    (100000000)
	sbci temp4, BYTE4    (100000000)
	brcc FUNKTION_HEX_ASC_100000000
	dec  temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp9) auf dem Stack sichern            
	subi temp1, BYTE1   (-100000000)
	sbci temp2, BYTE2   (-100000000)
	sbci temp3, BYTE3   (-100000000)
	sbci temp4, BYTE4   (-100000000)
	clr temp
FUNKTION_HEX_ASC_10000000:; 10.000.000
	inc temp
	subi temp1, BYTE1    (10000000)
	sbci temp2, BYTE2    (10000000)
	sbci temp3, BYTE3    (10000000)
	sbci temp4, BYTE4    (10000000)
	brcc FUNKTION_HEX_ASC_10000000
	dec  temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp8) auf dem Stack sichern            
	subi temp1, BYTE1   (-10000000)
	sbci temp2, BYTE2   (-10000000)
	sbci temp3, BYTE3   (-10000000)
	sbci temp4, BYTE4   (-10000000)
	clr temp
FUNKTION_HEX_ASC_1000000:; 1.000.000
	inc temp
	subi temp1, BYTE1    (1000000)
	sbci temp2, BYTE2    (1000000)
	sbci temp3, BYTE3    (1000000)
	brcc FUNKTION_HEX_ASC_1000000
	dec  temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp7) auf dem Stack sichern            
	subi temp1, BYTE1   (-1000000)
	sbci temp2, BYTE2   (-1000000)
	sbci temp3, BYTE3   (-1000000)
	clr temp
FUNKTION_HEX_ASC_100000:
	inc temp
	subi temp1, BYTE1    (100000)
	sbci temp2, BYTE2    (100000)
	sbci temp3, BYTE3    (100000)
	brcc FUNKTION_HEX_ASC_100000
	dec  temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp6) auf dem Stack sichern            
	subi temp1, BYTE1   (-100000)
	sbci temp2, BYTE2   (-100000)
	sbci temp3, BYTE3   (-100000)
	clr temp
FUNKTION_HEX_ASC_10000:
	inc temp
	subi temp1, BYTE1    (10000)
	sbci temp2, BYTE2    (10000)
	sbci temp3, BYTE3    (10000)
	brcc FUNKTION_HEX_ASC_10000
	dec  temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp5) auf dem Stack sichern            
	subi temp1, BYTE1  (-10000)
	sbci temp2, BYTE2  (-10000)
	sbci temp3, BYTE3  (-10000)
	clr temp
FUNKTION_HEX_ASC_1000:
	inc temp
	subi temp1, low  (1000)
	sbci temp2, HIGH (1000)
	brcc FUNKTION_HEX_ASC_1000
	dec temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp4) auf dem Stack sichern            
	subi temp1, low  (-1000)
	sbci temp2, HIGH (-1000)
	clr temp
FUNKTION_HEX_ASC_100:
	inc temp
	subi temp1, low  (100)
	sbci temp2, HIGH (100)
	brcc FUNKTION_HEX_ASC_100
	dec temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp3) auf dem Stack sichern            
	subi temp1, low  (-100)
	sbci temp2, HIGH (-100)
	clr temp
FUNKTION_HEX_ASC_10:
	inc temp
	subi temp1, low  (10)
	sbci temp2, HIGH (10)
	brcc FUNKTION_HEX_ASC_10
	dec temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp2) auf dem Stack sichern            
	subi temp1, low  (-10)
	sbci temp2, HIGH (-10)
FUNKTION_HEX_ASC_1:	
	subi temp1, -48		; HEX->ASC

	pop	TEMP2			; LESEN vom STACK (KOPIE)
	pop	TEMP3			; LESEN vom STACK (KOPIE)
	pop	TEMP4			; LESEN vom STACK (KOPIE)
	pop	TEMP5			; LESEN vom STACK (KOPIE)
	pop	TEMP6			; LESEN vom STACK (KOPIE)
	pop	TEMP7			; LESEN vom STACK (KOPIE)
	pop	TEMP8			; LESEN vom STACK (KOPIE)
	pop	TEMP9			; LESEN vom STACK (KOPIE)
	pop R0

;-------------------------------------------------------------------------------
	mov temp,temp1
	rcall ZAHL_LED_TEMP
	mov temp1,temp
;-------------------------------------------------------------------------------
	mov temp,temp2
	rcall ZAHL_LED_TEMP
	mov temp2,temp
;-------------------------------------------------------------------------------
	mov temp,temp3
	rcall ZAHL_LED_TEMP
	mov temp3,temp
;-------------------------------------------------------------------------------
	mov temp,temp4
	rcall ZAHL_LED_TEMP
	mov temp4,temp
;-------------------------------------------------------------------------------
	mov temp,temp5
	rcall ZAHL_LED_TEMP
	mov temp5,temp
;-------------------------------------------------------------------------------
	mov temp,temp6
	rcall ZAHL_LED_TEMP
	mov temp6,temp
;-------------------------------------------------------------------------------
	mov temp,temp7
	rcall ZAHL_LED_TEMP
	mov temp7,temp
;-------------------------------------------------------------------------------
	mov temp,temp8
	rcall ZAHL_LED_TEMP
	mov temp8,temp
;-------------------------------------------------------------------------------
	mov temp,temp9
	rcall ZAHL_LED_TEMP
	mov temp9,temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ZAHL_LED_TEMP:
	cpi temp,'0'
	breq ZAHL_LED_0
	cpi temp,'1'
	breq ZAHL_LED_1
	cpi temp,'2'
	breq ZAHL_LED_2
	cpi temp,'3'
	breq ZAHL_LED_3
	cpi temp,'4'
	breq ZAHL_LED_4
	cpi temp,'5'
	breq ZAHL_LED_5
	cpi temp,'6'
	breq ZAHL_LED_6
	cpi temp,'7'
	breq ZAHL_LED_7
	cpi temp,'8'
	breq ZAHL_LED_8
	cpi temp,'9'
	breq ZAHL_LED_9
	ldi temp,(ASCII_MINUS)
	ret
;-------------------------------------------------------------------------------
ZAHL_LED_0:
	ldi temp,(ASCII_0)
	ret
;-------------------------------------------------------------------------------
ZAHL_LED_1:
	ldi temp,(ASCII_1)
	ret
;-------------------------------------------------------------------------------
ZAHL_LED_2:
	ldi temp,(ASCII_2)
	ret
;-------------------------------------------------------------------------------
ZAHL_LED_3:
	ldi temp,(ASCII_3)
	ret
;-------------------------------------------------------------------------------
ZAHL_LED_4:
	ldi temp,(ASCII_4)
	ret
;-------------------------------------------------------------------------------
ZAHL_LED_5:
	ldi temp,(ASCII_5)
	ret
;-------------------------------------------------------------------------------
ZAHL_LED_6:
	ldi temp,(ASCII_6)
	ret
;-------------------------------------------------------------------------------
ZAHL_LED_7:
	ldi temp,(ASCII_7)
	ret
;-------------------------------------------------------------------------------
ZAHL_LED_8:
	ldi temp,(ASCII_8)
	ret
;-------------------------------------------------------------------------------
ZAHL_LED_9:
	ldi temp,(ASCII_9)
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; z.B. "02"																		
; out: temp1-2																	
HEX_TEMP1:
	push temp1
	mov temp,temp1
	andi temp,0b00001111
	rcall HEX_TEMP
	mov temp1,temp

	pop temp2
	mov temp,temp2
	swap temp
	andi temp,0b00001111
	rcall HEX_TEMP
	mov temp2,temp

	STS(adr_DIGIT7),NULL
	STS(adr_DIGIT6),NULL
	STS(adr_DIGIT5),NULL
	STS(adr_DIGIT4),NULL


	STS(adr_DIGIT3),NULL
	STS(adr_DIGIT2),NULL
	STS(adr_DIGIT1),temp2
	STS(adr_DIGIT0),temp1
	ret
;-------------------------------------------------------------------------------
HEX_TEMP:
cpi temp,0
	breq HEX_00
cpi temp,1
	breq HEX_01
cpi temp,2
	breq HEX_02
cpi temp,3
	breq HEX_03
cpi temp,4
	breq HEX_04
cpi temp,5
	breq HEX_05
cpi temp,6
	breq HEX_06
cpi temp,7
	breq HEX_07
cpi temp,8
	breq HEX_08
cpi temp,9
	breq HEX_09
cpi temp,10
	breq HEX_A
cpi temp,11
	breq HEX_B
cpi temp,12
	breq HEX_C
cpi temp,13
	breq HEX_D
cpi temp,14
	breq HEX_E
cpi temp,15
	rjmp HEX_F
;-------------------------------------------------------------------------------
; unteres Nibble																
HEX_00:
	ldi temp,(ASCII_0)
	ret
HEX_01:
	ldi temp,(ASCII_1)
	ret
HEX_02:
	ldi temp,(ASCII_2)
	ret
HEX_03:
	ldi temp,(ASCII_3)
	ret
HEX_04:
	ldi temp,(ASCII_4)
	ret
HEX_05:
	ldi temp,(ASCII_5)
	ret
HEX_06:
	ldi temp,(ASCII_6)
	ret
HEX_07:
	ldi temp,(ASCII_7)
	ret
HEX_08:
	ldi temp,(ASCII_8)
	ret
HEX_09:
	ldi temp,(ASCII_9)
	ret
HEX_A:
	ldi temp,(ASCII_A)
	ret
HEX_B:
	ldi temp,(ASCII_B)
	ret
HEX_C:
	ldi temp,(ASCII_C)
	ret
HEX_D:
	ldi temp,(ASCII_D)
	ret
HEX_E:
	ldi temp,(ASCII_E)
	ret
HEX_F:
	ldi temp,(ASCII_F)
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################

