; ##############################################################################
; ##############################################################################
; ##############################################################################
DISPLAY:
	LDS temp,(adr_DIGIT_NR)	; laden									
	inc temp				; +1									
	STS(adr_DIGIT_NR),temp	; sichern								
	dec temp				; -1									

	cpi temp,0
	breq DISPLAY0			; vergleich								
	cpi temp,1
	breq DISPLAY1
	cpi temp,2
	breq DISPLAY2
	cpi temp,3
	breq DISPLAY3
	cpi temp,4
	breq DISPLAY4
	cpi temp,5
	breq DISPLAY5
	cpi temp,6
	breq DISPLAY6
	cpi temp,7
	breq DISPLAY7

ret
;-------------------------------------------------------------------------------
DISPLAY0:
	LDS temp,(adr_DIGIT0)
	rcall BALKEN_TEMP
	rjmp DIGIT_0			; Digit ausgeben						
;-------------------------------------------------------------------------------
DISPLAY1:
	LDS temp,(adr_DIGIT1)	; laden									
	rcall BALKEN_TEMP		; Baken darstellen						
	rjmp DIGIT_1			; Digit	darstellen						
;-------------------------------------------------------------------------------
DISPLAY2:
	LDS temp,(adr_DIGIT2)
	rcall BALKEN_TEMP
	rjmp DIGIT_2
;-------------------------------------------------------------------------------
DISPLAY3:
	LDS temp,(adr_DIGIT3)
	rcall BALKEN_TEMP
	rjmp DIGIT_3
;-------------------------------------------------------------------------------
DISPLAY4:
	LDS temp,(adr_DIGIT4)
	rcall BALKEN_TEMP
	rjmp DIGIT_4
;-------------------------------------------------------------------------------
DISPLAY5:
	LDS temp,(adr_DIGIT5)
	rcall BALKEN_TEMP
	rjmp DIGIT_5
;-------------------------------------------------------------------------------
DISPLAY6:
	LDS temp,(adr_DIGIT6)
	rcall BALKEN_TEMP
	rjmp DIGIT_6
;-------------------------------------------------------------------------------
DISPLAY7:
	STS(adr_DIGIT_NR),NULL 	; Null !								
	LDS temp,(adr_DIGIT7)
	rcall BALKEN_TEMP
	rjmp DIGIT_7
; ##############################################################################
; ##############################################################################
; ##############################################################################
BALKEN_TEMP:
;-------------------------------------------------------------------------------
; Punkt 			(L=on)														
	sbrs temp,7				; Skip if Bit in Register is Set		
	LED_DAT_H
	sbrc temp,7				; Skip if Bit in Register is Clear		
	LED_DAT_L
	LED_ENABLE
;-------------------------------------------------------------------------------
; g		 			(L=on)														
	sbrs temp,6				; Skip if Bit in Register is Set		
	LED_DAT_H
	sbrc temp,6				; Skip if Bit in Register is Clear		
	LED_DAT_L
	LED_ENABLE
;-------------------------------------------------------------------------------
; f		 			(L=on)														
	sbrs temp,5				; Skip if Bit in Register is Set		
	LED_DAT_H
	sbrc temp,5				; Skip if Bit in Register is Clear		
	LED_DAT_L
	LED_ENABLE
;-------------------------------------------------------------------------------
; e		 			(L=on)														
	sbrs temp,4				; Skip if Bit in Register is Set		
	LED_DAT_H
	sbrc temp,4				; Skip if Bit in Register is Clear		
	LED_DAT_L
	LED_ENABLE
;-------------------------------------------------------------------------------
; d		 			(L=on)														
	sbrs temp,3				; Skip if Bit in Register is Set		
	LED_DAT_H
	sbrc temp,3				; Skip if Bit in Register is Clear		
	LED_DAT_L
	LED_ENABLE
;-------------------------------------------------------------------------------
; c		 			(L=on)														
	sbrs temp,2				; Skip if Bit in Register is Set		
	LED_DAT_H
	sbrc temp,2				; Skip if Bit in Register is Clear		
	LED_DAT_L
	LED_ENABLE
;-------------------------------------------------------------------------------
; b		 			(L=on)														
	sbrs temp,1				; Skip if Bit in Register is Set		
	LED_DAT_H
	sbrc temp,1				; Skip if Bit in Register is Clear		
	LED_DAT_L
	LED_ENABLE
;-------------------------------------------------------------------------------
; a		 			(L=on)														
	sbrs temp,0				; Skip if Bit in Register is Set		
	LED_DAT_H
	sbrc temp,0				; Skip if Bit in Register is Clear		
	LED_DAT_L
	LED_ENABLE
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; unten rechts																	
DIGIT_0:
	LED_DAT_H		;*0 unten rechts	(H=on)
	LED_ENABLE
	LED_DAT_L		; 1					(H=on)
	LED_ENABLE
	LED_DAT_L		; 2					(H=on)
	LED_ENABLE
	LED_DAT_L		; 3 unten links		(H=on)
	LED_ENABLE
	LED_DAT_L		; 4 oben rechts		(H=on)
	LED_ENABLE
	LED_DAT_L		; 5					(H=on)
	LED_ENABLE
	LED_DAT_L		; 6					(H=on)
	LED_ENABLE
	LED_DAT_L		; 7 oben links		(H=on)
	LED_ENABLE
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
DIGIT_1:
	LED_DAT_L		; 0 unten rechts	(H=on)
	LED_ENABLE
	LED_DAT_H		;*1					(H=on)
	LED_ENABLE
	LED_DAT_L		; 2					(H=on)
	LED_ENABLE
	LED_DAT_L		; 3 unten links		(H=on)
	LED_ENABLE
	LED_DAT_L		; 4 oben rechts		(H=on)
	LED_ENABLE
	LED_DAT_L		; 5					(H=on)
	LED_ENABLE
	LED_DAT_L		; 6					(H=on)
	LED_ENABLE
	LED_DAT_L		; 7 oben links		(H=on)
	LED_ENABLE
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
DIGIT_2:
	LED_DAT_L		; 0 unten rechts	(H=on)
	LED_ENABLE
	LED_DAT_L		; 1					(H=on)
	LED_ENABLE
	LED_DAT_H		;*2					(H=on)
	LED_ENABLE
	LED_DAT_L		; 3 unten links		(H=on)
	LED_ENABLE
	LED_DAT_L		; 4 oben rechts		(H=on)
	LED_ENABLE
	LED_DAT_L		; 5					(H=on)
	LED_ENABLE
	LED_DAT_L		; 6					(H=on)
	LED_ENABLE
	LED_DAT_L		; 7 oben links		(H=on)
	LED_ENABLE
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
DIGIT_3:
	LED_DAT_L		; 0 unten rechts	(H=on)
	LED_ENABLE
	LED_DAT_L		; 1					(H=on)
	LED_ENABLE
	LED_DAT_L		; 2					(H=on)
	LED_ENABLE
	LED_DAT_H		;*3 unten links		(H=on)
	LED_ENABLE
	LED_DAT_L		; 4 oben rechts		(H=on)
	LED_ENABLE
	LED_DAT_L		; 5					(H=on)
	LED_ENABLE
	LED_DAT_L		; 6					(H=on)
	LED_ENABLE
	LED_DAT_L		; 7 oben links		(H=on)
	LED_ENABLE
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
DIGIT_4:
	LED_DAT_L		; 0 unten rechts	(H=on)
	LED_ENABLE
	LED_DAT_L		; 1					(H=on)
	LED_ENABLE
	LED_DAT_L		; 2					(H=on)
	LED_ENABLE
	LED_DAT_L		; 3 unten links		(H=on)
	LED_ENABLE
	LED_DAT_H		;*4 oben rechts		(H=on)
	LED_ENABLE
	LED_DAT_L		; 5					(H=on)
	LED_ENABLE
	LED_DAT_L		; 6					(H=on)
	LED_ENABLE
	LED_DAT_L		; 7 oben links		(H=on)
	LED_ENABLE
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
DIGIT_5:
	LED_DAT_L		; 0 unten rechts	(H=on)
	LED_ENABLE
	LED_DAT_L		; 1					(H=on)
	LED_ENABLE
	LED_DAT_L		; 2					(H=on)
	LED_ENABLE
	LED_DAT_L		; 3 unten links		(H=on)
	LED_ENABLE
	LED_DAT_L		; 4 oben rechts		(H=on)
	LED_ENABLE
	LED_DAT_H		;*5					(H=on)
	LED_ENABLE
	LED_DAT_L		; 6					(H=on)
	LED_ENABLE
	LED_DAT_L		; 7 oben links		(H=on)
	LED_ENABLE
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
DIGIT_6:
	LED_DAT_L		; 0 unten rechts	(H=on)
	LED_ENABLE
	LED_DAT_L		; 1					(H=on)
	LED_ENABLE
	LED_DAT_L		; 2					(H=on)
	LED_ENABLE
	LED_DAT_L		; 3 unten links		(H=on)
	LED_ENABLE
	LED_DAT_L		; 4 oben rechts		(H=on)
	LED_ENABLE
	LED_DAT_L		; 5					(H=on)
	LED_ENABLE
	LED_DAT_H		;*6					(H=on)
	LED_ENABLE
	LED_DAT_L		; 7 oben links		(H=on)
	LED_ENABLE
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
DIGIT_7:
	LED_DAT_L		; 0 unten rechts	(H=on)
	LED_ENABLE
	LED_DAT_L		; 1					(H=on)
	LED_ENABLE
	LED_DAT_L		; 2					(H=on)
	LED_ENABLE
	LED_DAT_L		; 3 unten links		(H=on)
	LED_ENABLE
	LED_DAT_L		; 4 oben rechts		(H=on)
	LED_ENABLE
	LED_DAT_L		; 5					(H=on)
	LED_ENABLE
	LED_DAT_L		; 6					(H=on)
	LED_ENABLE
	LED_DAT_H		; 7 oben links		(H=on)
	LED_ENABLE
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################

